<?php
$script = 'sitemap.php';
$count = 100;
$lastpost = true;
$asc = false;


// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('SKIP_SESSIONCREATE', 1);
define('DIE_QUIETLY', 1);
define('THIS_SCRIPT', 'sitemap');

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special data templates from the datastore
$phrasegroups = array('forum');
$specialtemplates = array();

// pre-cache templates used by specific actions
$actiontemplates = array();

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################

// We don't want no stinkin' sessionhash
$vbulletin->session->vars['sessionurl'] =
$vbulletin->session->vars['sessionurl_q'] =
$vbulletin->session->vars['sessionurl_js'] =
$vbulletin->session->vars['sessionhash'] = '';

$vbulletin->input->clean_array_gpc('r', array(
	'offset'  => TYPE_UINT,
));

if($vbulletin->GPC['offset']) $offset=$vbulletin->GPC['offset'];
else $offset = 0;

// check to see if there is a forum preference

	foreach (array_keys($vbulletin->forumcache) AS $forumid)
	{
		$forumperms =& $vbulletin->userinfo['forumpermissions']["$forumid"];
		if ($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']
			AND ($forumperms & $vbulletin->bf_ugp_forumpermissions['canviewothers'])
			AND (($forumperms & $vbulletin->bf_ugp_forumpermissions['canviewthreads']))
			AND verify_forum_password($forumid, $vbulletin->forumcache["$forumid"]['password'], false)
		)
		{
			$forumchoice[] = $forumid;
		}
	}

	if (!empty($forumchoice))
	{
		$forumsql = "AND thread.forumid IN(" . implode(',', $forumchoice) . ")";
	}
	else
	{
		$forumsql = "";
	}

if (empty($forumchoice))
{	// no access to view selected forums
	exit;
}

$threadcount = $db->query_first_slave("
	SELECT count(*)	AS totalthreads	
	FROM " . TABLE_PREFIX . "thread AS thread
	WHERE 1=1
		$forumsql
		AND thread.visible = 1
		AND open <> 10
");
$totalthreads = $threadcount['totalthreads'];

$threadcache = array();
// query last threads from visible / chosen forums
$threads = $db->query_read_slave("
	SELECT thread.threadid, thread.title, thread.lastpost		
	FROM " . TABLE_PREFIX . "thread AS thread
	WHERE 1=1
		$forumsql
		AND thread.visible = 1
		AND open <> 10
	ORDER BY " . ($lastpost ? "thread.lastpost" : "thread.dateline") . ($asc?" ASC ":" DESC ") ."
	LIMIT ".$offset.",$count
");
while ($thread = $db->fetch_array($threads))
{ // fetch the threads
	// remove sessionhash from urls:
	$threadcache[] = $thread;
}

$output .= $stylevar[htmldoctype];
$output .= "<html xmlns='http://www.w3.org/1999/xhtml' dir='$stylevar[textdirection]' lang='$stylevar[languagecode]' xml:lang='$stylevar[languagecode]'><head>";
$output .= "<meta http-equiv='Content-Type' content='text/html; charset=".$stylevar[charset]."' />";
$output .= "<title>".$vbulletin->options['bbtitle']."</title></head><body>";

$output .= "\r\n<br/><h1>".$vbphrase['view_full_version'].": <a href='".$vbulletin->options['bburl']."'>".$vbulletin->options['bbtitle']."</a></h1>";
$output .= "\r\n<br/>".$vbphrase['go_to_page'];
$page_current=intval($offset/$count)+1;
$page_max=intval($totalthreads/$count)+1;

for($i=1;$i<=$page_max;$i++)
{
	if($i<=20||$i==$page_max||($i>$page_current-5&&$i<$page_current+5)) {
		$output .= "<a href='".$script."?offset=".(($i-1)*$count)."'>".$i."</a> ";
	}
}

if (!empty($threadcache))
{
	foreach ($threadcache AS $threadnum => $thread)
	{
		$output .= "\r\n<br/>&raquo; <a href='". $vbulletin->options['bburl'] . "/showthread.php?t=".$thread['threadid']."'>".$thread['title']."</a>";
	}
}
$output .= "</body></html>";

echo $output;
?>